/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 354 (Exercise B.2.4)
**
*/

new;
library rpb,pgraph;

__output = 0;

cls;

/*
**> Question 2
**
*/

sigma = 0.3225/sqrt(260);
print ftosa(100*sigma,"%lf",3,2);

S0 = 100;
sigma = 0.02;
Delta = 0.5;
Gamma_ = 0.02;

print;
print "=====================  Question 2.a  =======================================";

VaR = 2.33 * Delta * sigma * S0;
print ftosa(VaR,"%lf",3,2);

print;
print "=====================  Question 2.b  =======================================";

VaR = -0.5 * Gamma_ * (sigma^2) * (S0^2) + 2.33 * sqrt( (Delta * sigma * S0)^2 + 0.5 * (Gamma_^2) * (sigma^4) * (S0^4)) ;
print ftosa(VaR,"%lf",3,2);

print;
print "=====================  Question 2.c  =======================================";

mu_L = -0.5 * Gamma_ * (sigma^2) * (S0^2);
print ftos(mu_L,"mu(L) = %lf",3,4);

sigma_L = sqrt( (Delta * sigma * S0)^2 + 0.5 * (Gamma_^2) * (sigma^4) * (S0^4));
print ftos(sigma_L,"sigma(L) = %lf",3,4);

sk_L = -(3 * (Delta^2) * (Gamma_^1) * (sigma^4) * (S0^4) +  (Gamma_^3) * (sigma^6) * (S0^6)) / 
        ( ( (Delta * sigma * S0)^2 + 0.5 * (Gamma_^2) * (sigma^4) * (S0^4) )^(3/2) );
print ftos(sk_L,"skewness = %lf",3,4);

sk_L = -(6*sqrt(2) * (Delta^2) * (Gamma_^1) * (sigma^4) * (S0^4) +  2*sqrt(2) * (Gamma_^3) * (sigma^6) * (S0^6)) / 
        ( ( 2 * (Delta * sigma * S0)^2 + (Gamma_^2) * (sigma^4) * (S0^4) )^(3/2) );
print ftos(sk_L,"skewness = %lf",3,4);

kt_L = (3 * (Delta^4) * (sigma^4) * (S0^4) + 15 * (Delta^2) * (Gamma_^2) * (sigma^6) * (S0^6)  + 15/4 * (Gamma_^4) * (sigma^8) * (S0^8)) / 
      ( ( (Delta * sigma * S0)^2 + 0.5 * (Gamma_^2) * (sigma^4) * (S0^4) )^(2) ) - 3.0;
print ftos(kt_L,"kurtosis = %lf",3,4);
kt_L = (12 * (Delta^2) * (Gamma_^2) * (sigma^6) * (S0^6)  + 3 * (Gamma_^4) * (sigma^8) * (S0^8)) / 
      ( ( (Delta * sigma * S0)^2 + 0.5 * (Gamma_^2) * (sigma^4) * (S0^4) )^(2) );
print ftos(kt_L,"kurtosis = %lf",3,4);

skewness = sk_L;
kurtosis = kt_L;

alpha = 0.99;
z = cdfni(alpha);
z = z + 1/6 * ((z^2)-1) .* skewness + 
        1/24 * ((z^3)-3*z) .* kurtosis - 
        1/36 * (2*(z^3)-5*z) .* skewness^2;
print ftos(z,"z = %lf",3,4);

VaR = mu_L + z * sigma_L;
print ftos(VaR,"VaR = %lf",3,2);

/*
**> Question 3
**
*/

print;
print "=====================  Question 3.a  =======================================";

n = 3;
ns = 1000000;

A = rndu(n,n);
A = A*A';
call invpd(A);

X = rndn(n,nS);
Y = zeros(nS,1);

i = 1;
do until i > nS;
  Y[i] = X[.,i]'*A*X[.,i];
  i = i + 1;
endo;

fn trace_matrix(M) = sumc(diag(M));

ms = meanc(Y)|meanc(Y^2)|meanc(Y^3)|meanc(Y^4);
tr1 = trace_matrix(A);
tr2 = trace_matrix(A*A);
tr3 = trace_matrix(A*A*A);
tr4 = trace_matrix(A*A*A*A);

m = zeros(4,1);
m[1] = tr1;
m[2] = tr1^2 + 2*tr2;
m[3] = tr1^3 + 6*tr1*tr2 + 8*tr3;
m[4] = tr1^4 + 32*tr1*tr3 + 12*(tr2^2) + 12*(tr1^2)*tr2 + 48*tr4;
m[4] = tr1^4 + 32*tr1*tr3 + 12*(tr2^2) + 12*(tr1^2)*tr2 + 48*tr4;

print ms~m;

/*
**> Question 4
**
*/

let S0[2,1] = 100 50;
let Delta[2,1] = 0.40 0.50;
let Gamma_[2,2] = 0.02 0.01
                 0.01 0.03;
let Sigma[2,2] = 0.20 0.05
                 0.05 0.15;
let R[2,1] = -0.05 0.10;
let x[2,1] = 5 8;
 
St = (1 + R) .* S0;

print;
print "=====================  Question 4.a  =======================================";

PnL = x' * ( Delta .* (St - S0)) + 0.5 * x' * (Gamma_ .* (St - S0) .* (St - S0)') * x;
print ftosa(PnL,"PnL = %lf",3,2);

Delta_tilde = x .* Delta .* S0;
Gamma_tilde = x .* x' .* Gamma_ .* S0 .* S0';

PnL = Delta_tilde'R + 0.5 * R'*Gamma_tilde* R;
print ftosa(PnL,"PnL = %lf",3,2);

/*
**> Question 5
**
*/

Use_Mean = 1;

print;
print "=====================  Question 5.a  =======================================";

let S0[3,1] = 100 100 100;
let Delta[3,1] = 0.0 0.0 0.0;
let rho = 1.0
          0.5   1.0
          0.0  -0.5 1.0;
rho = xpnd(rho);
call invpd(rho);
let Gamma_ = 0.04 0.01 0.01;
Gamma_ = sqrt(Gamma_);
Gamma_ = rho .* Gamma_ .* Gamma_';

let rho = 1.00
          0.50  1.00
          0.25  0.15 1.00; 
rho = xpnd(rho);
call invpd(rho);
let sigma = 0.01 0.015 0.02;
Sigma = rho .* sigma .* sigma';

print "delta = ";
print ftosa(100*Delta,"%lf",3,2);
print "Gamma = ";
print ftosa(100*Gamma_,"%lf",3,4);
print "Sigma = ";
print ftosa(100*Sigma,"%lf",3,2);

let x = 50 20 30;

Delta_tilde = x .* Delta .* S0;
Gamma_tilde = x .* x' .* Gamma_ .* S0 .* S0';

A = Gamma_tilde*Sigma;
tr1 = trace_matrix(A);
tr2 = trace_matrix(A*A);
tr3 = trace_matrix(A*A*A);
tr4 = trace_matrix(A*A*A*A);

mu_L = -0.5*tr1*Use_Mean;
sigma_L = sqrt(0.5*tr2);
gamma1_L = -(2*sqrt(2)*tr3)/(tr2^1.5);
gamma2_L = (12*tr4)/(tr2^2);

print ftos(mu_L,"mu(L) = %lf",3,4);
print ftos(sigma_L,"sigma(L) = %lf",3,4);
print ftos(gamma1_L,"gamma1(L) = %lf",3,4);
print ftos(gamma2_L,"gamma2(L) = %lf",3,4);

alpha = 0.99;
VaR = cdfni(alpha) * sqrt(Delta_tilde'*Sigma*Delta_tilde);
print ftosa(VaR,"VaR = %lf",3,2);

VaR = -0.5*tr1 + cdfni(alpha) * sqrt(Delta_tilde'*Sigma*Delta_tilde + 0.5*tr2);
print ftosa(VaR,"VaR = %lf",3,2);

skewness = gamma1_L;
kurtosis = gamma2_L;

z = cdfni(alpha);
z = z + 1/6 * ((z^2)-1) .* skewness + 
        1/24 * ((z^3)-3*z) .* kurtosis - 
        1/36 * (2*(z^3)-5*z) .* skewness^2;
VaR = mu_L + z * sigma_L;
print ftos(VaR,"VaR = %lf",3,2);

z = cdfni(alpha);
z = z + 1/6 * ((z^2)-1) .* skewness + 
        1/24 * ((z^3)-3*z) .* kurtosis;
VaR = mu_L + z * sigma_L;
print ftos(VaR,"VaR = %lf",3,2);

print;
print "=====================  Question 5.b  =======================================";

let Delta[3,1] = 0.50 0.40 0.60;
print "delta = ";
print ftosa(100*Delta,"%lf",3,2);

Delta_tilde = x .* Delta .* S0;

alpha = 0.99;
VaR = cdfni(alpha) * sqrt(Delta_tilde'*Sigma*Delta_tilde);

MR = cdfni(alpha) .* (Sigma*Delta_tilde) .* (Delta .* S0) / sqrt(Delta_tilde'*Sigma*Delta_tilde);
RC = x .* MR;
RC_star = RC/VaR;

print "---- Delta ----";

Results = x~MR~RC~100*RC_star|(error(0)~error(0)~VaR~100*sumc(RC_star));
print ftosa(Results,"%lf",3,2);

proc Compute_VaR1_Fn(x);
  local d,VaR;

  d = x .* Delta .* S0;
  VaR = cdfni(alpha) * sqrt(d'*Sigma*d);

  retp(VaR);
endp;

VaR = Compute_VaR1_Fn(x);
MR = gradp(&Compute_VaR1_Fn,x)';
RC = x .* MR;
RC_star = RC/VaR;

print "---- Delta ----";

Results = x~MR~RC~100*RC_star|(error(0)~error(0)~VaR~100*sumc(RC_star));
print ftosa(Results,"%lf",3,2);

proc Compute_VaR2_Fn(x);
  local d,g,A,tr1,tr2,tr3,tr4,VaR;

  d = x .* Delta .* S0;
  g =  x .* x' .* Gamma_ .* S0 .* S0';
  A = g*Sigma;
  tr1 = trace_matrix(A);
  tr2 = trace_matrix(A*A);
  tr3 = trace_matrix(A*A*A);
  tr4 = trace_matrix(A*A*A*A);
  VaR = -0.5*tr1*Use_Mean + cdfni(alpha) * sqrt(d'*Sigma*d + 0.5*tr2);

  retp(VaR);
endp;

VaR = Compute_VaR2_Fn(x);
MR = gradp(&Compute_VaR2_Fn,x)';
RC = x .* MR;
RC_star = RC/VaR;

print "---- Delta-Gamma ----";

Results = x~MR~RC~100*RC_star|(error(0)~error(0)~VaR~100*sumc(RC_star));
print ftosa(Results,"%lf",3,2);
print ftosa(VaR,"VaR = %lf",3,2);

proc Compute_VaR3_Fn(x);
  local d,g,A,tr1,tr2,tr3,tr4;
  local mu_L,sigma_L,gamma1_L,gamma2_L,z,VaR;

  d = x .* Delta .* S0;
  g =  x .* x' .* Gamma_ .* S0 .* S0';
  A = g*Sigma;
  tr1 = trace_matrix(A);
  tr2 = trace_matrix(A*A);
  tr3 = trace_matrix(A*A*A);
  tr4 = trace_matrix(A*A*A*A);

  mu_L = -0.5*tr1*Use_Mean;
  sigma_L = sqrt(d'*Sigma*d + 0.5*tr2);
  gamma1_L = -(6*sqrt(2) * (d'*Sigma*g*Sigma*d) + 2*sqrt(2)*tr3)/ ( (2 * d'Sigma*d + tr2)^1.5 );

  z = cdfni(alpha);
  z = z + 1/6 * ((z^2)-1) .* gamma1_L - 
        1/36 * (2*(z^3)-5*z) .* gamma1_L^2;
  VaR = mu_L + z * sigma_L;

  retp(VaR);
endp;

VaR = Compute_VaR3_Fn(x);

print "---- Cornish-Fisher ----";
print ftosa(VaR,"VaR = %lf",3,2);

print "---- ERC portfolio ----";

proc (1) = Compute_ERC_Fn(x);
  local d,MR,RC,u,rss;

  d = x .* Delta .* S0;
  MR = cdfni(alpha) .* (Sigma*d) .* (Delta .* S0) / sqrt(d'*Sigma*d);
  RC = x .* MR;
  u = RC - RC';
  rss = sumc(vec(u^2));

  retp(rss);
endp;

_sqp_A = ones(1,3); _sqp_B = 1;
_sqp_Bounds = 0~1;
{x,fmin,grd,retcode} = sqpSolve(&Compute_ERC_Fn,ones(3,1)/3);

x = x * 100;

VaR = Compute_VaR1_Fn(x);
MR = gradp(&Compute_VaR1_Fn,x)';
RC = x .* MR;
RC_star = RC/VaR;

Results = x~MR~RC~100*RC_star|(error(0)~error(0)~VaR~100*sumc(RC_star));
print ftosa(Results,"%lf",3,2);
