/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 356 (Exercise B.2.6)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

/*
**> Question 1.a
**
*/

Let A[6,3] = 0.9    -0.2      0.5
             1.1    -0.5     -0.3
             1.2    -0.3      0.2
             0.8     0.1     -0.7
             0.5     0.5      0.5
             1.4     0.4     -0.2;
n = rows(A);
m = cols(A);

let sigma_F = 0.20 0.05 0.08;
Omega = diagrv(eye(m),sigma_F^2);
let sigma_A = 0.04 0.05 0.08 0.05 0.10 0.07;
D = diagrv(eye(n),sigma_A^2);

Sigma = A*Omega*A' + D;
var = diag(Sigma);
var_c = diag(A*Omega*A');
var_f = A^2 .* sigma_F' .* sigma_F';
var_s = diag(D);
vol_A = sqrt(diag(Sigma));
rho_A = Sigma ./ vol_A ./ vol_A';

print;
print "=====================  Question 1.a  =======================================";

Results = 100*vol_A~100*(var_f~var_c~var_s)./var;
print ftosa(Results,"%lf",3,2);

print ftosa(100*vol_A,"%lf",3,2);
print ftosa(100*rho_A,"%lf",3,1);

/*
**> Question 1.b
**
*/

A_plus = pinv(A);
A2_plus = invpd(A'A)*A';

B = A';  
B_plus = pinv(B);
B2_plus = B'invpd(B*B');
B_tilde_plus = null(B_plus');
B_tilde =  pinv(null(B_plus')) * (eye(n) - B_plus*A');
B2_tilde = null(A')';

print;
print "=====================  Question 1.b  =======================================";

print ftosa(A_Plus,"%lf",3,3);

print ftosa(B_Plus,"%lf",3,3);

print ftosa(B_tilde_plus,"%lf",3,3);

print ftosa(B_tilde,"%lf",3,3);

print "---------------------";

print ftosa(A2_Plus,"%lf",3,3);

print ftosa(B2_Plus,"%lf",3,3);

print ftosa(B2_tilde,"%lf",3,3);

/*
**> Question 1.c
**
*/

let x = 0.20 0.10 0.15 0.05 0.30 0.20;
y = A'x;
y_tilde = B_tilde*x;
x2 = B_plus * y + B_tilde_plus*y_tilde;

print;
print "=====================  Question 1.c  =======================================";

print ftosa(100*y,"%lf",3,3);
print ftosa(100*y_tilde,"%lf",3,3);

x_c = B_plus*y;
x_s = B_tilde_plus*y_tilde;

print ftosa(100*(x~x_c~x_s~(x_c+x_s)),"%lf",3,3);

/*
**> Question 1.d
**
*/

{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma,A,Omega,D);
Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));

print;
print "=====================  Question 1.d  =======================================";

print ftosa(100*Results,"%lf",3,2);

/*
**> Question 1.e
**
*/

{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma,A,Omega,D);
Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));

A2 = A ~ eye(n);
Omega2 = diagrv(eye(m+n),(sigma_F|sigma_A)^2);
D2 = zeros(n,n);
Sigma2 = A2*Omega2*A2' + D2;

vol_A2 = sqrt(diag(Sigma2));
rho_A2 = Sigma2 ./ vol_A2 ./ vol_A2';

print;
print "=====================  Question 1.e  =======================================";

print ftosa(100*vol_A,"%lf",3,2);
print ftosa(100*rho_A,"%lf",3,2);

{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma2,A2,Omega2,D2);
Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

/*
**> Question 2.a
**
*/

let indx_factors = 1 2 3;
let b_factors = 0.80 0.10 0.10;

{x,y,mr_y,rc_y,prc_y} = Compute_RB_Factor(0,Sigma,A,Omega,D,b_factors,indx_factors,0);
{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma,A,Omega,D);
{vol,mr_x,rc_x,prc_x} = Compute_Risk_Contribution(x,Sigma);

print;
print "=====================  Question 2.a  =======================================";

Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

Results = (x~mr_x~rc_x~prc_x)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

/*
**> Question 2.b
**
*/

_rpb_factor_bounds = -1;

let indx_factors = 1 2 3;
let b_factors = 0.10 0.40 0.40;

{x,y,y_mr,y_rc,y_prc} = Compute_RB_Factor(0,Sigma,A,Omega,D,b_factors,indx_factors,0);
{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma,A,Omega,D);
{vol,mr_x,rc_x,prc_x} = Compute_Risk_Contribution(x,Sigma);

print;
print "=====================  Question 2.b  =======================================";

Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

Results = (x~mr_x~rc_x~prc_x)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

/*
**> Question 2.c
**
*/

_rpb_factor_bounds = -1;

let indx_factors = 1 2 3;
let b_factors = 0.05 0.90 0.05;

{x,y,y_mr,y_rc,y_prc} = Compute_RB_Factor(0,Sigma,A,Omega,D,b_factors,indx_factors,0);
{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma,A,Omega,D);

{vol,mr_x,rc_x,prc_x} = Compute_Risk_Contribution(x,Sigma);


print;
print "=====================  Question 2.c  =======================================";

Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

Results = (x~mr_x~rc_x~prc_x)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

/*
**> Question 2.d
**
*/

_rpb_factor_bounds = -1;

let indx_factors = 1 2 3;
let b_factors = 0.05 0.05 0.90;

{x,y,y_mr,y_rc,y_prc} = Compute_RB_Factor(0,Sigma,A,Omega,D,b_factors,indx_factors,0);
{vol,y,mr_y,rc_y,prc_y} = Compute_RC_Factor(x,Sigma,A,Omega,D);

{vol,mr_x,rc_x,prc_x} = Compute_Risk_Contribution(x,Sigma);


print;
print "=====================  Question 2.d  =======================================";

Results = (y~mr_y~rc_y~prc_y)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);

Results = (x~mr_x~rc_x~prc_x)|(error(0)~error(0)~vol~error(0));
print ftosa(100*Results,"%lf",3,2);


