/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 69 (Table 1.19)
**
*/

new;
library rpb,pgraph;
cls;

__output = 0;

let mu =    0.05 0.06 0.08 0.06;
let _sigma_ = 0.15 0.20 0.25 0.30;
n = rows(_Sigma_);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

Sigma = rho .* _sigma_ .* _sigma_';

print ftosa(100*(_sigma_~rho),"%lf",5,2);
print "--------------------------------------------------------------------------------------------------------";

A = ones(1,n); B = 1; e = ones(n,1);
mu_star = 0.06;

Bounds = (-10~10 ) .* e;
{x1,mu1,sigma1,lambda1,retcode} = Compute_MVO_Portfolio(mu,Sigma,A,B,0,0,Bounds,mu_star,1); 
{x_star,fmin,lambda1,lamdba2,retcode} = _Shrinkage_JM_MVO(x1,mu,Sigma,0,mu_star); 

Bounds = (0.10~0.40) .* e;
{x_tilde,Sigma_tilde,lambda} = Shrinkage_JM_MVO(mu,Sigma,Bounds,mu_star);
let sv = 0.5981 0.0662 0.7991 -0.4634;
{x_bar,fmin,lambda1,lamdba2,retcode} = _Shrinkage_JM_MVO(sv,mu,Sigma_tilde,0,mu_star); 

results = x_star~x_tilde~x_bar;
print ftosa(100*results,"%lf",5,3);
print "--------------------------------------------------------------------------------------------------------";

_sigma_tilde = sqrt(diag(Sigma_tilde));
rho_tilde = Sigma_tilde ./ _sigma_tilde ./ _sigma_tilde';

print ftosa(100*(x_tilde~lambda),"%lf",5,3)$~ftosa(100*(_sigma_tilde~rho_tilde),"%lf",5,2);
print "--------------------------------------------------------------------------------------------------------";

vol_star = sqrt(x_star'Sigma*x_star);
vol_tilde = sqrt(x_tilde'Sigma*x_tilde);
mu_star = x_star'mu;
mu_tilde = x_tilde'mu;

print;
print ftosa(100*(vol_star~vol_tilde),"%lf",3,2);
print ftosa(100*(mu_star~mu_tilde),"%lf",3,2);

