/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 113 (Table 2.13)
**
*/

new;
library rpb,pgraph;

cls;

all_results = miss(zeros(3*4,5),0);

let sigma = 0.20 0.10 0.05 0.10;
let rho =   1.00
            0.50  1.00
           -0.25 -0.25  1.00
           -0.25 -0.25  0.50  1.00;

rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);

n = rows(cov);
let b = 0.50 0.50 0.00 0.00;

i = 1;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_results[1+(i-1)*3:i*3,1:4] = 100*(x~mr~prc)';
all_results[1+(i-1)*3+1,5] = 100*vol;

i = 2;
let indx = 1 2;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_results[1+(i-1)*3:i*3,1:4] = 100*(x~mr~prc)';
all_results[1+(i-1)*3+1,5] = 100*vol;

i = 3;
let indx = 1 2 3;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_results[1+(i-1)*3:i*3,1:4] = 100*(x~mr~prc)';
all_results[1+(i-1)*3+1,5] = 100*vol;

i = 4;
let indx = 1 2 4;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_results[1+(i-1)*3:i*3,1:4] = 100*(x~mr~prc)';
all_results[1+(i-1)*3+1,5] = 100*vol;

cls;
print ftosa(all_results[1:3,.],"%lf",3,2);
print ftosa(all_results[4:6,.],"%lf",3,2);
print ftosa(all_results[7:9,.],"%lf",3,2);
print ftosa(all_results[10:12,.],"%lf",3,2);


