/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 162 (Figure 3.2)
**
*/

new;
library rpb,pgraph;

cls;

FileName = "data\\data-rafi.dat";
data = loadd(FileName);
data = selif(data,(data[.,1] .>= 20000101) .and (data[.,1] .<= 20120630));
vnames = "" $+ getname(FileName);
Index = Data[.,2 3];
Index = 100 * Index ./ Index[1,.];

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _pcolor = 1|2|12; _plwidth = 10;
  xtics(0,12*13,12,1);
  let xlab = "2000" "01" "02" "03" "04" "05" "06" "07" "08" "09" "10" "11" "12" "13";
  asclabel(xlab,0);  
  _plegstr = "FTSE RAFI US Index\000S&P 500 Index";
  _plegctl = {2 5 1 5};
  graphprt("-c=1 -cf=chap3-2-2-1.eps");
  xy(0,Index[.,2 1]);