/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 236 (Table 4.23)
**
*/

new;
library rpb,pgraph;

cls;

/*
**> DEBT-RB
**
*/

FileName = "Results\\sovereign-bonds-egbi.fmt";
loadm egbi = ^FileName;

FileName = "Results\\sovereign-bonds-rb-egbi.fmt";
loadm rb_egbi = ^FileName;

FileName = "Results\\sovereign-bonds-debt.fmt";
loadm debt = ^FileName;

FileName = "Results\\sovereign-bonds-rb-debt.fmt";
loadm rb_debt = ^FileName;

FileName = "Results\\sovereign-bonds-gdp.fmt";
loadm gdp = ^FileName;

FileName = "Results\\sovereign-bonds-rb-gdp.fmt";
loadm rb_gdp = ^FileName;

nCountries = 11;
indx_dates = 1;
indx_x = seqa(2,1,nCountries);
indx_rc = seqa(nCountries+2,1,nCountries);
indx_vol = 2*nCountries+2;

Dates = egbi[.,indx_dates];
data = rb_debt;

let user_dates = 20080701 20090701 20100701 20110701 20120301 20120530;
nCols = rows(user_dates);
indx = closest_index(user_dates,Dates);
user_dates = Dates[indx];

x = data[indx,indx_x];
rc = data[indx,indx_rc];
vol = data[indx,indx_vol];
results = miss(zeros(nCountries+1,2*nCols),0);
Results[1:nCountries,seqa(1,2,nCols)] = rc';
Results[.,1+seqa(1,2,nCols)] = x'|vol';

let fmt[12,3] = "%lf" 10 1 "%lf" 5 1
                "%lf" 10 1 "%lf" 5 1
                "%lf" 10 1 "%lf" 5 1
                "%lf" 10 1 "%lf" 5 1
                "%lf" 10 1 "%lf" 5 1
                "%lf" 10 1 "%lf" 5 1;
call printfm(100*results,1,fmt);
print;

let user_dates = 20080101 20100101 20110101 20120101;
nCols = rows(user_dates);
indx = closest_index(user_dates,Dates);
user_dates = Dates[indx];

x = data[indx,indx_x];
rc = data[indx,indx_rc];
vol = data[indx,indx_vol];
results = miss(zeros(nCountries+1,2*nCols),0);
Results[1:nCountries,seqa(1,2,nCols)] = rc';
Results[.,1+seqa(1,2,nCols)] = x'|vol';

print "---------------------------------------------------------------";
call printfm(100*results,1,fmt[1:8,.]);

