/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 266 (Limiting the turnover)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.20 0.15 0.25 0.20;
let rho   = 1.00
            0.20 1.00
            0.10 0.15 1.00
            0.20 0.20 0.50 1.00;
rho = xpnd(rho);
call invpd(rho);
cov = rho .* sigma .* sigma';
n = rows(cov);

b = ones(n,1)/n;

alpha = seqa(0,1/100,101);
nAlpha = rows(alpha);
tau = zeros(nAlpha,1);

let x0 = 0.20 0.40 0.05 0.35; 
{vol0,mr0,rc0,b0} = Compute_Risk_Contribution(x0,cov);

i = 1;
do until i > nAlpha;
  b1 = alpha[i]*b + (1-alpha[i]) * b0;
  {x,vol,mr,rc,pc} = Compute_RB_Portfolio(x0,cov,b1);
  tau[i] = sumc(abs(x-x0));
  i = i + 1;
endo;

tau1 = tau;

let x0 = 0.10 0.10 0.10 0.70; 
{vol0,mr0,rc0,b0} = Compute_Risk_Contribution(x0,cov);

i = 1;
do until i > nAlpha;
  b1 = alpha[i]*b + (1-alpha[i]) * b0;
  {x,vol,mr,rc,pc} = Compute_RB_Portfolio(x0,cov,b1);
  tau[i] = sumc(abs(x-x0));
  i = i + 1;
endo;

tau2 = tau;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|3; _plwidth = 10; _pcolor = 1|4;
  xtics(0,1,0.20,2);
  ytics(0,100,20,2);
  xlabel("\216\202a\201");
  ylabel("\216\202t\201 (in %)");
  xy(alpha,100*(tau1~tau2));